

## This is a threaded Sensor engine
## GPL from stefanux @ libero .it
## created for osX Bar

import XBarGetMail
import os
import string
import thread


## Developer Guide
## you have to call the XBarSensorInit for first
## add your sensors :)
## XBarSensorAdd(...)
## - index of icon
## - type of sensor
## - - 0 none [never modify]
## - - 1 EMail [command is the Icon when there is email]
## - - 2 tell Icon [command is the command to run, the command will return the icon to load]
## - - 3 Animation [command must the radix of the list of png]
## - - 4 Replace Text
## - - 5 Check about mounts [cmd is the cmd to execute]
## - command

## Index of sensors icons
SysSensorsIndex=[]
## Sensor Types
SysSensorsType=[]
## Sensor Commands
SysSensorsCmd=[]
## Sensor Status
SysSensorsStatus=[]
## Thread Mutex
SysSensorsWait=[]

## List Icon Sensors
SysSensorsAliasCmd = []
SysSensorsAlias = []
SysSensorsAliasIcon = []

## External References
theWidget=0
theXBarEngine=0

## XBarSensorInit
## This will Initialize the Engine
##
def XBarSensorInit(widget,eXBarEngine):
	global theWidget
	global theXBarEngine
	theWidget=widget
	theXBarEngine=eXBarEngine
	print "osX Bar Thread Sensor Engine Module ready."

def XBarSensorLoadAlias(Alias,AliasIcon,AliasCmd):
	global SysSensorsAlias
	global SysSensorsAliasCmd
	global SysSensorsAliasIcon
	for ssI in range (len(Alias)):
		SysSensorsAlias.append(Alias)
		SysSensorsAliasCmd.append(AliasCmd)
		SysSensorsAliasIcon.append(AliasIcon)

## XBarSensorAdd
## This will load sensor from lists
##
def XBarSensorLoad(sensorIndex,sensortipe,command):
	for ssI in range (len(sensorIndex)):
		XBarSensorAdd(sensorIndex[ssI],sensortipe[ssI],command[ssI])
## XBarSensorAdd
## This will add new sensor to the osX Bar
##
def XBarSensorAdd(sensorIndex,sensortipe,command):
	global SysSensorsIndex
	global SysSensorsCmd
	global SysSensorsType
	global SysSensorsWait
	global SysSensorsStatus
	SysSensorsIndex.append(sensorIndex)
	SysSensorsCmd.append(command)
	SysSensorsType.append(sensortipe)
	SysSensorsWait.append(0)
	SysSensorsStatus.append(0)
	print "Sensor added on " + str(sensorIndex) + " Icon"

## XBarSensorUpdateSensor
## This will Update sensor to the osX Bar
## like XBarSensorUpdate but index is real from mine list
def XBarSensorUpdateSensor(realSensorIndex):
	sensorIndex=SysSensorsIndex[realSensorIndex]
	## ok sensor index if good
	print "Sensor update " + str(realSensorIndex) + " type: " + str(SysSensorsType[realSensorIndex])
	if(SysSensorsType[realSensorIndex]==0):
		print "none sensor, have you got a wrong config?"
	elif(SysSensorsType[realSensorIndex]==1):
		## EMail Check
		## Setup the Mutex
		SysSensorsWait[realSensorIndex]=SysSensorsWait[realSensorIndex]+1
		## Refreshing EMail
		thread.start_new_thread(XBarSensorUpdateWrapper,(sensorIndex,XBarGetMail.EMailCheck,realSensorIndex,))
		##XBarSensorUpdateWrapper(sensorIndex,XBarGetMail.EMailCheck,realSensorIndex)
	elif(SysSensorsType[realSensorIndex]==2):
		## Tell Icon
		## Setup the Mutex
		SysSensorsWait[realSensorIndex]=SysSensorsWait[realSensorIndex]+1
		## Refreshing EMail
		thread.start_new_thread(XBarSensorUpdateWrapper,(sensorIndex,XBarSensorTellIcon,realSensorIndex,))
		##XBarSensorUpdateWrapper(sensorIndex,XBarSensorTellIcon,realSensorIndex)
	elif(SysSensorsType[realSensorIndex]==3):
		## Animation
		## Setup the Mutex
		SysSensorsWait[realSensorIndex]=SysSensorsWait[realSensorIndex]+1
		thread.start_new_thread(XBarSensorUpdateWrapper,(sensorIndex,XBarSensorAnimation,realSensorIndex,))
		##XBarSensorUpdateWrapper(sensorIndex,XBarSensorAnimation,realSensorIndex)
	elif(SysSensorsType[realSensorIndex]==4):
		## Change the Text
		## Setup the Mutex
		SysSensorsWait[realSensorIndex]=SysSensorsWait[realSensorIndex]+1
		thread.start_new_thread(XBarSensorUpdateWrapper,(sensorIndex,XBarSensorTellIcon,realSensorIndex,))
		##XBarSensorUpdateWrapper(sensorIndex,XBarSensorTellIcon,realSensorIndex)
	elif(SysSensorsType[realSensorIndex]==5):
		## Mounts Sensor
		## Setup the Mutex
		SysSensorsWait[realSensorIndex]=SysSensorsWait[realSensorIndex]+1
		##thread.start_new_thread(XBarSensorUpdateWrapper,(sensorIndex,XBarSensorMounts,realSensorIndex,))
		XBarSensorUpdateWrapper(sensorIndex,XBarSensorMounts,realSensorIndex)
	else:
		print "Sensor not implemented, have you got a wrong config?"


## XBarSensorUpdate
## This will Update sensor to the osX Bar
##
def XBarSensorUpdate(sensorIndex):
	global SysSensorsIndex
	global SysSensorsCmd
	global SysSensorsType
	global SysSensorsWait
	for realSensorIndex in range (len(SysSensorsWait)):
		if(sensorIndex==SysSensorsIndex[realSensorIndex]):
			XBarSensorUpdateSensor(realSensorIndex)

def XBarSensorAnimation(sensorIndex):
	## Animation progress
	global SysSensorsStatus
	return (SysSensorsStatus[sensorIndex]+1)

def XBarSensorTellIcon(sensorIndex):
	## RunCmd
	NewIconFile=os.popen(SysSensorsCmd[sensorIndex],"r")
	NewIconFile=string.strip(NewIconFile.read(1024))
	return NewIconFile

def XBarSensorMounts(sensorIndex):
	## RunCmd
	global SysSensorsAlias
	global SysSensorsAliasIcon
	global SysSensorsAliasCmd
	NewIconFile=os.popen(SysSensorsCmd[sensorIndex],"r")
	## Exstract any single line
	NumberOfLines=0
	while 1:
		MountLine=NewIconFile.readline()
		if len(MountLine) == 0:
			break
		NumberOfLines=NumberOfLines+1
		MountLine=MountLine.strip()
		for i in range(len(SysSensorsAlias)):
			if(str(SysSensorsAlias[i])==str(MountLine)):
				## got match with icon
				## Addin the Icon
				theXBarEngine.AddIcon(SysSensorsAlias[i],SysSensorsAliasIcon[i],SysSensorsAliasCmd[i])
				break
	return NumberOfLines
## XBarSensorUpdateWrapper
## This will Update sensor to the osX Bar
## Wrapper for the mutex
def XBarSensorUpdateWrapper(sensorIndex,functionupdater,realIndex):
	global SysSensorsIndex
	global SysSensorsCmd
	global SysSensorsType
	global SysSensorsWait
	global SysSensorsStatus
	returncode=functionupdater(realIndex)
	if(SysSensorsStatus[realIndex]!=returncode):
		SysSensorsStatus[realIndex]=returncode
		if(SysSensorsType[realIndex]==1):
			## EMail Check
			## Setup the Mutex
			SysSensorsWait[realIndex]=SysSensorsWait[realIndex]-1
			## Refreshing EMail
			theXBarEngine.UpdateIcon(sensorIndex,SysSensorsCmd[realIndex])
		elif(SysSensorsType[realIndex]==2):
			## Tell Icon
			## Setup the Mutex
			SysSensorsWait[realIndex]=SysSensorsWait[realIndex]-1
			## Got the Icon
			theXBarEngine.UpdateIcon(sensorIndex,returncode)
		elif(SysSensorsType[realIndex]==3):
			## Animation
			## Setup the Mutex
			SysSensorsWait[realIndex]=SysSensorsWait[realIndex]-1
			## Got the Icon
			theAniPngs=SysSensorsCmd[realIndex]+str(SysSensorsStatus[realIndex])+".png"
			if(os.path.exists(theAniPngs)):
				theXBarEngine.UpdateIcon(sensorIndex,theAniPngs)
			else:
				SysSensorsStatus[realIndex]=0
				theAniPngs=SysSensorsCmd[realIndex]+str(SysSensorsStatus[realIndex])+".png"
				theXBarEngine.UpdateIcon(sensorIndex,theAniPngs)
		elif(SysSensorsType[realIndex]==4):
			## Tell Text
			## Setup the Mutex
			SysSensorsWait[realIndex]=SysSensorsWait[realIndex]-1
			## Got the Icon
			theXBarEngine.UpdateText(sensorIndex,returncode)
		elif(SysSensorsType[realIndex]==5):
			## List Icon
			## Setup the Mutex
			SysSensorsWait[realIndex]=SysSensorsWait[realIndex]-1
			##theXBarEngine.UpdateText(sensorIndex,returncode)
 		else:
			print "Sensor not implemented, have you got a wrong config?"



## When loading osX Bar extensions
print "osX Bar Thread Sensor Engine Module loaded. [Version 0.1]"
